/* 
 * AppController.m created by phr on 2000-08-27 11:38:58 +0000
 *
 * GNUstep Application Controller
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: AppController.m,v 1.14 2003/07/05 22:12:15 cehardin Exp $
 */


#include "AppController.h"
#include "DockTileCell.h"

@implementation AppController

static NSDictionary *infoDict = nil;

+ (void)initialize
{
  NSMutableDictionary *defaults = [NSMutableDictionary dictionary];

  /*
   * Register your app's defaults here by adding objects to the
   * dictionary, eg
   *
   * [defaults setObject:anObject forKey:keyForThatObject];
   *
   */
  
  [[NSUserDefaults standardUserDefaults] registerDefaults:defaults];
  [[NSUserDefaults standardUserDefaults] synchronize];
}

- (id)init
{
  if ((self = [super init])) {
  }
  return self;
}

- (void)dealloc
{
  [super dealloc];
}

- (void)awakeFromNib
{
}

- (void)applicationDidFinishLaunching:(NSNotification *)notif
{
    workspace = [NSWorkspace sharedWorkspace];
    [self makeWindow];
    
    NSNotificationCenter *workspaceNotificationCenter;
    workspaceNotificationCenter = [workspace notificationCenter];
    [workspaceNotificationCenter addObserver:self 
	selector:@selector(workspaceNotification:)    
	name:nil
	object:nil];
}



- (void)makeWindow
{
    NSRect rect;    
    rect = [[NSScreen mainScreen] frame];
    rect.origin.x = rect.size.width - 64;
    rect.origin.y = rect.size.height- 64;
    rect.size.width = 64;
    rect.size.height = 64;
    
    dock = [[Dock alloc] initWithFrame: rect ];
    
    window = [[NSWindow alloc] initWithContentRect: rect
	styleMask: NSBorderlessWindowMask
	//styleMask: NSTitledWindowMask
	backing: NSBackingStoreBuffered
	defer: YES];
	
	

    [window setTitle: @"GSDock"];

    [window setContentView: dock];
    
    //cant add tiles until the dock has been put into a window
    [dock addRecyclerTile];
    [dock addLogoTile];

    [self addRunningAppTiles];
    
    [window orderFrontRegardless];
    
    [window setLevel: NSFloatingWindowLevel];
    
    [window makeKeyWindow];    
    
    //[window setAcceptsMouseMovedEvents:YES];
    //[dock setNeedsDisplay:YES];
    
}

- (void) workspaceNotification:(NSNotification*) notification 
{
    NSDictionary *dict;
    NSString *notificationName;
    
    NSLog(@"%@ userInfo:%a", [notification name], [notification userInfo]);
    
    dict = [notification userInfo];
    notificationName = [notification name];
    
    if( [notificationName isEqualToString: @"NSWorkspaceWillLaunchApplicationNotification"] )
    {
	NSString *appPath, *appName;
	NSNumber *pid;
	appPath = [dict objectForKey: @"NSApplicationPath"];
	appName = [dict objectForKey: @"NSApplicationName"];
	pid = [dict objectForKey: @"NSApplicationProcessIdentifier"];
	NSLog(@"Adding Running App");
	NSLog(appPath);
	NSLog(appName);
	if( [dock getTile: appPath] == nil ) {
	    [dock addApplicationTile: appPath withPID:(NSNumber*)pid withStatus:DTLaunching];
	}
    }
    
    else if( [notificationName isEqualToString: @"NSWorkspaceDidLaunchApplicationNotification"] )
    {
        NSString *appPath, *appName;
	NSNumber *pid;
	appPath = [dict objectForKey: @"NSApplicationPath"];
	appName = [dict objectForKey: @"NSApplicationName"];
	pid = [dict objectForKey: @"NSApplicationProcessIdentifier"];
	
	if( [dock getTile: appPath] == nil ) {
	    [dock addApplicationTile: appPath withPID:(NSNumber*)pid withStatus:DTLaunched];
	}
        else {
            [[dock getTile: appPath] setTileStatus: DTLaunched];
        }
    }
    
    else if( [notificationName isEqualToString: @"NSWorkspaceDidTerminateApplicationNotification"] )
    {
	NSString *appPath, *appName;
	NSNumber *pid;
	
	appPath = [dict objectForKey: @"NSApplicationPath"];
	appName = [dict objectForKey: @"NSApplicationName"];
	pid = [dict objectForKey: @"NSApplicationProcessIdentifier"];
	[dock applicationTerminated: appPath];
    }	
    
}

- (void)addRunningAppTiles
{
    NSArray *runningApps;
    NSEnumerator *enumerator;
    NSDictionary *dict;
    
    NSLog(@"addRunningAppTiles");
    
    runningApps = [workspace launchedApplications];
    enumerator = [runningApps objectEnumerator];
    
    printf("There are %i running apps\n", [runningApps count]);
    
    while( nil != (dict = [enumerator nextObject])) {
	NSString *appPath, *appName;
	NSNumber *pid;
	
	appPath = [dict objectForKey: @"NSApplicationPath"];
	appName = [dict objectForKey: @"NSApplicationName"];
	pid = [dict objectForKey: @"NSApplicationProcessIdentifier"];
	NSLog(@"Adding Running App");
	NSLog(appPath);
	NSLog(appName);
        [dock addApplicationTile: appPath withPID: pid withStatus:DTLaunched];
    }
}


 




- (BOOL)applicationShouldTerminate:(id)sender
{
  return YES;
}

- (void)applicationWillTerminate:(NSNotification *)notification
{
}

- (BOOL)application:(NSApplication *)application openFile:(NSString *)fileName
{
    return NO;
}

- (void)showPrefPanel:(id)sender
{
}

- (void)showInfoPanel:(id)sender
{
  [[NSApplication sharedApplication] orderFrontStandardAboutPanel:sender];
}

- (void)workspaceObserver:(id)sender
{
}

@end
