/* 
 * Dock.h created by root on 2003-05-03 21:59:36 +0000
 *
 * Project GSDock
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: Dock.h,v 1.15 2003/07/06 01:10:29 cehardin Exp $
 */

#ifndef _DOCK_H_
#define _DOCK_H_

#include <AppKit/AppKit.h>
#include "DockTileCell.h"
    
@interface Dock : NSMatrix
{
    BOOL dragSessionInProgress;
    DockTileCell *tileDraggingTo;
    BOOL appsDragged;
    BOOL mixedDragged;
    NSArray *filesDragged;
    NSPasteboard *currentDraggingPasteboard;
}

- (NSMenu*) menuForEvent: (NSEvent*) theEvent;

- (BOOL) isFlipped;

- (DockTileCell*) tileAtPoint:(NSPoint) location;

- initWithFrame:(NSRect) rect;

- (void)registerDragAndDrop;

- (void)doubleClicked:(id) sender;

- (void)resizeDock;

- (int)numberOfTiles;

- (void)addLogoTile;

- (void)addRecyclerTile;

- (DockTileCell*)getTile:(NSString*) path;

//Add an App tile at a specific place
- (void)addApplicationTileAtIndex:(int)place withPath:(NSString*)path withPID:(NSNumber*)pid withStatus:(DockTileStatus) status;

//Add an App tile right above the recycler
- (void)addApplicationTile:(NSString*)path withPID:(NSNumber*)pid withStatus:(DockTileStatus) status;

- (BOOL)removeApplicationTile:(NSString*)path;

- (void)applicationTerminated:(NSString*) appPath;

- (void)removeTileAtIndex: (int)place;

- (NSDragOperation)draggingEntered:(id <NSDraggingInfo>) sender;

- (void)draggingExited:(id <NSDraggingInfo>) sender;
- (BOOL)prepareforDragOperation:(id <NSDraggingInfo>) sender;

- (BOOL)performDragOperation:(id <NSDraggingInfo>) sender; 


- (NSDragOperation)draggingUpdated:(id <NSDraggingInfo>) sender;

@end

#endif // _DOCK_H_

