/* 
 * DockTileCell.h created by root on 2003-05-03 21:59:36 +0000
 *
 * Project GSDock
 *
 * Created with ProjectCenter - http://www.gnustep.org
 *
 * $Id: DockTileCell.h,v 1.11 2003/07/06 01:10:29 cehardin Exp $
 */

#ifndef _DOCKTILECELL_H_
#define _DOCKTILECELL_H_

#include <AppKit/AppKit.h>

typedef enum _DockTileType{
    DTLogo,
    DTRecycler,
    DTApplication
} DockTileType;
    
typedef enum _DockTileStatus {
    DTGhost,
    DTLaunching,
    DTLaunched,
    DTNotRunning
} DockTileStatus;

@interface DockTileCell : NSActionCell
{
    DockTileType _type;
    DockTileStatus _status;
    NSImage *tileImage, *tileHLImage;
    NSImage *tileNonRunningImage, *tileNonRunningHLImage;
    NSString *_path;  //the path and actual file (/System/Applications/SomeApp.app)
    float iconSize; //used for animations when launching
    NSTimer *launchingTimer;
    BOOL animationShrinking;
    BOOL _keep;  //whether this tile stays on the dock when not launched
}

- init;

- (void) doubleClicked;

- (DockTileType) tileType;

- (BOOL) keep;

- (void) setKeep:(BOOL)flag;


- (void) setPath: (NSString*) path;

- (NSString*) path;

- (void) setTileType: (DockTileType) type;

- (void) setTileStatus: (DockTileStatus) status;

- (DockTileStatus) tileStatus;

- (void) drawInteriorWithFrame:(NSRect)cellFrame inView:(NSView *)controlView;

- (BOOL) trackMouse:(NSEvent *)theEvent inRect:(NSRect)cellFrame ofView:(NSView *)controlView untilMouseUp:(BOOL)untilMouseUp;

- (BOOL) startTrackingAt:(NSPoint)startPoint inView:(NSView *)controlView; 

- (BOOL) continueTracking:(NSPoint)lastPoint at:(NSPoint)currentPoint inView:(NSView *)controlView;

- (void) stopTracking:(NSPoint)lastPoint at:(NSPoint)stopPoint inView:(NSView *)controlView mouseIsUp:(BOOL)flag;

- (void) launchingTimerFired:(NSTimer*)timer;

- (BOOL) doesAcceptFiles:(NSArray*) files;

- (void) quitDockItemSelected:(id) sender;

- (void) keepMenuItemSelected:(id) sender;

- (void) showLocationItemSelected:(id) sender;

@end

#endif // _DOCKTILECELL_H_

